import * as React from 'react';
import Slider from "@mui/material/Slider";
import Typograpy from "@mui/material/Typography";
import { vec3 } from 'gl-matrix';

export type UniformSet = {
    light_color: vec3,
    light_ambientIntensity:number,
    light_direction: vec3,
    light_diffuseIntensity:number,
};

export function MenuBar(prop:{u:UniformSet,onUniformChange:(u:UniformSet)=>void}){
    const [uniform,setUniform] = React.useState(prop.u);
    const onDiffIntenseChange = (_,v)=>{
        setUniform({...uniform,light_diffuseIntensity:v/100});
    };
    const onAmbientIntenseChange = (_,v)=>{
        setUniform({...uniform,light_ambientIntensity:v/100});
    };
    React.useEffect(()=>{
        prop.onUniformChange(uniform);
    });
    const diffuseIntense = uniform.light_diffuseIntensity*100;
    const ambientIntense = uniform.light_ambientIntensity*100;
    return (<div>
        <Typograpy variant="h4">Light Diffuse Intense</Typograpy>
        <Slider aria-label="Small" valueLabelDisplay="auto" onChange={onDiffIntenseChange} value={Math.round(diffuseIntense)}></Slider>
        <Typograpy variant="h4">Light Ambient Intense</Typograpy>
        <Slider aria-label="Small" valueLabelDisplay="auto" onChange={onAmbientIntenseChange} value={Math.round(ambientIntense)}></Slider>
    </div>);
}